Bug 234110 - RAID5 on 2 disks
RAID5 on 2 disks
Product: Fedora
Classification: Fedora
Component: anaconda (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Anaconda Maintenance Team
: Reopened
Depends On:
  Show dependency treegraph
Reported: 2007-03-26 23:27 EDT by Eli
Modified: 2007-11-30 17:12 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-04-02 14:40:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Test case to demonstrate the viability of 2-disk RAID5 (1.10 KB, application/x-shellscript)
2007-03-30 21:59 EDT, Eli
no flags Details

  None (edit)
Description Eli 2007-03-26 23:27:05 EDT
Description of problem:
I want to setup RAID5, not RAID1, on a pair of disks during install, but 
anaconda insists that I must have 3 disks.

Version-Release number of selected component (if applicable):
Fedora Core 6

How reproducible:

Steps to Reproduce:
1. Select RAID5 with 2 disks
2. It says you must have at least 3 devices to setup RAID5.
Actual results:

Expected results:
Setup RAID5 on 2 disks.

Additional info:

Yeah, RAID5 on 2 disks doesn't make much sense most of the time.  But it has 
one significant advantage over RAID1 on 2 disks: you can later extend the 
RAID5 onto a 3rd disk using mdadm --grow, and get more usable space.  You 
can't do that with RAID1.

In my case, I have 2x400GB drives.  That's enough space for me for the next 
year or so, but I expect to outgrow it soon.  I'd really like to be able to 
add a 3rd drive when I need 800GB.
Comment 1 Jeremy Katz 2007-03-27 11:53:07 EDT
We don't support doing degraded RAIDs like this because people would expect to
get the benefit of the RAID and then file bugs when they didn't. 
Comment 2 Eli 2007-03-27 21:35:29 EDT
While I can see some use cases for setting up degraded RAIDs, that's not what 
I was trying to propose.

RAID5 with 2 disks gives you the same redundancy as RAID1, but with the 
ability to add disks later.  2 x 400GB drives, RAID5'ed gives you 400GB of 
usable space, and if either fail, you're ok.  Same as RAID1.  But you can add 
disks to a RAID5 with mdadm --grow.  So I could add a third 400GB drive to the 
2x400 RAID5, and my usable capacity will grow from 400GB to 800GB.  I can't do 
that with RAID1.
Comment 3 David Cantrell 2007-03-30 11:27:38 EDT

Where's your parity disk with only 2 drives?  We cannot support a scenario like
this during installation.  Closing as WONTFIX.
Comment 4 Eli 2007-03-30 21:59:40 EDT
Created attachment 151341 [details]
Test case to demonstrate the viability of 2-disk RAID5
Comment 5 Eli 2007-03-30 22:06:58 EDT
"Where's your parity disk with only 2 drives?"

Spread across the two drives, just like it's spread across three drives.
Using the same diagram style as the link you provided:

3-disk case:
disk0 | disk1 | disk2
 A1      B1      P1
 A2      P2      C2
 P3      B3      C3

2-disk case:
disk0 | disk1
 A1      P1
 P2      B2
 A3      P3

Please look at the test case I attached as a demonstration of the validity of 
this configuration.  If there is something wrong with the test case, please 
point it out.

Test case requirements:
 - must be run as root
 - uses 200MB of disk space
 - uses /dev/md0, /dev/loop0, and /dev/loop1
 - takes 1 minute 20 seconds to run on my 2.6GHz notebook
Comment 6 David Cantrell 2007-04-02 14:35:21 EDT
I fail to see the advantage to RAID 5 on two disks.  You mention the only
advantage you want is the ability to grow the array a year or so down the road
when you need 800GB of storage space.  That's some serious planning going on,
but do you not forsee yourself reinstalling in that timeframe or upgrading or
even switching to new hardware?  Maybe not, I dunno.

Also, the performance hit you take with RAID 5 vs. straight up mirroring when
you only have two drives seems like a waste of resources.  For that year of time
before you need more space, why not running mirroring and take the best
performance you can get given the hardware you have?
Comment 7 David Cantrell 2007-04-02 14:40:39 EDT
By definition, RAID 5 with fewer than three disks is in a degraded state and
we're not going to support these scenarios during installation via anaconda.  If
you absolutely need this for your environment, consider a kickstart file
tailored to your environment.

Note You need to log in before you can comment on or make changes to this bug.